/* C code for functions not covered in bush_os.ads          */
/* Part of BUSH                                             */
/*                                                          */
/* I didn't want to resort to C, but I need to use stat()   */
/* and manually declaring the structure in Ada is extremely */
/* unportable between UNIXes -- KB                          */

#include <sys/types.h>
#include <sys/stat.h>

/* IS EXECUTABLE FILE                                       */
/*                                                          */
/* True if file exists, is regular, and is executable       */

int C_is_executable_file( char * path ) {
  struct stat info;
  int result = 0;
  if ( stat( path, &info ) == 0 ) {
     if ( info.st_mode & S_IFREG ) {
        if ( getuid() == info.st_uid ) {
           result = (info.st_mode & S_IXUSR ) > 0;
        } else if ( getgid() == info.st_gid ) {
           result = (info.st_mode & S_IXGRP ) > 0;
        } else {
           result = (info.st_mode & S_IXOTH ) > 0;
        }
     }
  }
  return result;
}

/* end of c_os.c */

