------------------------------------------------------------------------------
-- BUSH Numerics Package Parser                                             --
--                                                                          --
-- Part of BUSH                                                             --
------------------------------------------------------------------------------
--                                                                          --
--                 Copyright (C) 2001 Ken O. Burtch & FSF                   --
--                                                                          --
-- This is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion.  This is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with this;  see file COPYING.  If not, write --
-- to  the Free Software Foundation,  59 Temple Place - Suite 330,  Boston, --
-- MA 02111-1307, USA.                                                      --
--                                                                          --
-- This is maintained at http://www.vaxxine.com/pegasoft                    --
--                                                                          --
------------------------------------------------------------------------------

with ada.strings.unbounded, ada.numerics.float_random;
use ada.strings.unbounded;

package parser_numerics is


random_generator : ada.numerics.float_random.generator;

procedure ParseNumericsAbs( result : out unbounded_string );
procedure ParseNumericsRandom( result : out unbounded_string );
procedure ParseNumericsShiftLeft( result : out unbounded_string );
procedure ParseNumericsShiftRight( result : out unbounded_string );
procedure ParseNumericsRotateLeft( result : out unbounded_string );
procedure ParseNumericsRotateRight( result : out unbounded_string );
procedure ParseNumericsASR( result : out unbounded_string );
procedure ParseNumericsSqrt( result : out unbounded_string );
procedure ParseNumericsLog( result : out unbounded_string );
procedure ParseNumericsExp( result : out unbounded_string );
procedure ParseNumericsSin( result : out unbounded_string );
procedure ParseNumericsCos( result : out unbounded_string );
procedure ParseNumericsTan( result : out unbounded_string );
procedure ParseNumericsCot( result : out unbounded_string );
procedure ParseNumericsArcSin( result : out unbounded_string );
procedure ParseNumericsArcCos( result : out unbounded_string );
procedure ParseNumericsArcTan( result : out unbounded_string );
procedure ParseNumericsArcCot( result : out unbounded_string );
procedure ParseNumericsSinH( result : out unbounded_string );
procedure ParseNumericsCosH( result : out unbounded_string );
procedure ParseNumericsTanH( result : out unbounded_string );
procedure ParseNumericsCoth( result : out unbounded_string );
procedure ParseNumericsArcSinH( result : out unbounded_string );
procedure ParseNumericsArcCosH( result : out unbounded_string );
procedure ParseNumericsArcTanH( result : out unbounded_string );
procedure ParseNumericsArcCotH( result : out unbounded_string );
procedure ParseNumericsFloor( result : out unbounded_string );
procedure ParseNumericsCeiling( result : out unbounded_string );
procedure ParseNumericsRounding( result : out unbounded_string );
procedure ParseNumericsUnbiasedRounding( result : out unbounded_string );
procedure ParseNumericsTruncation( result : out unbounded_string );
procedure ParseNumericsRemainder( result : out unbounded_string );
procedure ParseNumericsExponent( result : out unbounded_string );
procedure ParseNumericsFraction( result : out unbounded_string );
procedure ParseNumericsLeadingPart( result : out unbounded_string );
procedure ParseNumericsCopySign( result : out unbounded_string );
procedure ParseNumericsSturges( result : out unbounded_string );
procedure ParseNumericsMax( result : out unbounded_string );
procedure ParseNumericsMin( result : out unbounded_string );
procedure ParseNumericsMachine( result : out unbounded_string );
procedure ParseNumericsScaling( result : out unbounded_string );
procedure ParseNumericsValue( result : out unbounded_string );
procedure ParseNumericsPos( result : out unbounded_string );

end parser_numerics;
