------------------------------------------------------------------------------
-- BUSH Strings Package Parser                                              --
--                                                                          --
-- Part of BUSH                                                             --
------------------------------------------------------------------------------
--                                                                          --
--                 Copyright (C) 2001 Ken O. Burtch & FSF                   --
--                                                                          --
-- This is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion.  This is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with this;  see file COPYING.  If not, write --
-- to  the Free Software Foundation,  59 Temple Place - Suite 330,  Boston, --
-- MA 02111-1307, USA.                                                      --
--                                                                          --
-- This is maintained at http://www.vaxxine.com/pegasoft                    --
--                                                                          --
------------------------------------------------------------------------------

with ada.strings.unbounded;
use  ada.strings.unbounded;

package parser_strings is


---------------------------------------------------------
-- PARSE THE STRINGS PACKAGE
---------------------------------------------------------

procedure ParseStringsGlob( result : out unbounded_string );
procedure ParseStringsMatch( result : out unbounded_string );
procedure ParseStringsElement( result : in out unbounded_string );
procedure ParseStringsSlice( result : in out unbounded_string );
procedure ParseStringsIndex( result : in out unbounded_string );
procedure ParseStringsIndexNonBlank( result : in out unbounded_string );
procedure ParseStringsCount( result : in out unbounded_string );
procedure ParseStringsReplaceSlice( result : in out unbounded_string );
procedure ParseStringsInsert( result : in out unbounded_string );
procedure ParseStringsOverwrite( result : in out unbounded_string );
procedure ParseStringsDelete( result : in out unbounded_string );
procedure ParseStringsTrim( result : in out unbounded_string );
procedure ParseStringsLength( result : in out unbounded_string );
procedure ParseStringsHead( result : in out unbounded_string );
procedure ParseStringsTail( result : in out unbounded_string );
procedure ParseStringsField( result : in out unbounded_string );
procedure ParseStringsMkTemp( result : in out unbounded_string );
procedure ParseStringsVal( result : in out unbounded_string );
procedure ParseStringsImage( result : in out unbounded_string );

end parser_strings;
