------------------------------------------------------------------------------
-- BUSH Run UNIX/Linux Commands                                             --
--                                                                          --
-- Part of BUSH                                                             --
------------------------------------------------------------------------------
--                                                                          --
--                 Copyright (C) 2001 Ken O. Burtch & FSF                   --
--                                                                          --
-- This is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion.  This is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with this;  see file COPYING.  If not, write --
-- to  the Free Software Foundation,  59 Temple Place - Suite 330,  Boston, --
-- MA 02111-1307, USA.                                                      --
--                                                                          --
-- This is maintained at http://www.vaxxine.com/pegasoft                    --
--                                                                          --
------------------------------------------------------------------------------

with ada.strings.unbounded.text_io,
    gnat.os_lib;
use ada.strings.unbounded,
    ada.strings.unbounded.text_io,
    gnat.os_lib;

package run_cmd is

   procedure run( cmd : unbounded_string;
      ap : argument_list_access;
      success : out boolean;
      background : boolean := false;
      cache : boolean := true );
   -- run the specified command using the given arguments

   procedure run_inpipe( cmd : unbounded_string;
      ap : argument_list_access;
      success : out boolean;
      background : boolean := false;
      cache : boolean := true );
   -- run the specified command using the given arguments

   procedure run_frompipe( cmd : unbounded_string;
      ap : argument_list_access;
      success : out boolean;
      background : boolean := false;
      cache : boolean := true );
   -- run the specified command using the given arguments

   procedure run_bothpipe( cmd : unbounded_string;
      ap : argument_list_access;
      success : out boolean;
      background : boolean := false;
      cache : boolean := true );
   -- run the specified command using the given arguments

   procedure closePipeline;
   -- close off open pipes

   procedure free( ap : in out argument_list_access );
   -- deallocate an argument list

   procedure wait4Children;
   -- wait for completed child processes

   procedure updateJobStatus;
   -- check all jobs for their current status

   procedure putJobList;
   -- display the job list

end run_cmd;

