------------------------------------------------------------------------------
-- STRING UTIL                                                              --
--                                                                          --
-- Part of BUSH                                                             --
-- Designed and Programmed by Ken O. Burtch                                 --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
--                    Copyright (C) 2001 Ken O. Burtch                      --
--                                                                          --
-- This is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion.  This is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with this;  see file COPYING.  If not, write --
-- to  the Free Software Foundation,  59 Temple Place - Suite 330,  Boston, --
-- MA 02111-1307, USA.                                                      --
--                                                                          --
-- This is maintained at http://www.vaxxine.com/pegasoft                    --
--                                                                          --
------------------------------------------------------------------------------

with ada.strings.unbounded;
use ada.strings.unbounded;

package string_util is

procedure FixSpacing( s : in out unbounded_string );
-- remove leading and trailing spaces, as well as any double-spaces inside

function TypoOf( BadString, GoodString : unbounded_string ) return boolean;
-- 80% of all typos are single insertions, deletions, exchanges, or subs.

function ToLower( s : unbounded_string ) return unbounded_string;
-- convert string to lower case

function stringField( s : unbounded_string; delimiter : character; f : natural )
return unbounded_string;
-- return the fth field delimited by delimiter

procedure replaceField( s : in out unbounded_string; delimiter : character;
f : natural; field : string );
-- replace the fth field delimited by delimiter with field

end string_util;

