#!/bin/bash

bad_test() {
  echo "Running $1..."
  ../bush "$1" < /dev/null > /dev/null
  RESULT=$?
  TMP=`ls core 2>/dev/null`
  test -f ./test.txt && rm ./test.txt
  if [ ! -z "$TMP" ] ; then
     rm core
     echo
     echo "--- $1 FAILED WITH CORE DUMP ---"
     echo "Test was:"
     cat "$1"
     exit 1
  fi
  if [ $RESULT -eq 0 ] ; then
     echo
     echo "--- $1 TEST FAILED - status code $RESULT ---"
     echo "Test was:"
     cat "$1"
     exit 1
  fi
}

bad_test_wparam() {
  echo "Running $1..."
  ../bush "$1" a b c < /dev/null > /dev/null
  RESULT=$?
  TMP=`ls core 2>/dev/null`
  test -f ./test.txt && rm ./test.txt
  if [ ! -z "$TMP" ] ; then
     rm core
     echo
     echo "--- $1 FAILED WITH CORE DUMP ---"
     echo "Test was:"
     cat "$1"
     exit 1
  fi
  if [ $RESULT -eq 0 ] ; then
     echo
     echo "--- $1 TEST FAILED - status code $RESULT ---"
     echo "Test was:"
     cat "$1"
     exit 1
  fi
}

good_test() {
  echo "Running $1..."
  ../bush "$1" a b c
  if [ $? -ne 0 ] ; then
     echo "--- $1 TEST FAILED - status code $? ---"
     exit 1
  fi
  ../bush -n "$1" a b c
  if [ $? -ne 0 ] ; then
     echo "--- $1 TEST FAILED - status code $? ---"
     exit 1
  fi
}

# BUSH TEST SUITE

if [ "$1" = "-h" ] ; then
   echo "Bush test suite"
   echo
   echo "usage: $0 [-b]"
   echo " -b - bad syntax tests only"
   exit
fi

test -f ./test.txt && rm ./test.txt

if [ "$1" != "-b" ] ; then
   good_test "goodtest.bush"
   good_test "goodtest2.bush"
fi
echo
echo "Testing bad scripts:"
bad_test "badtest1.bush"
bad_test "badtest2.bush"
bad_test "badtest3.bush"
bad_test "badtest4.bush"
bad_test "badtest5.bush"
bad_test "badtest6.bush"
bad_test "badtest7.bush"
bad_test "badtest8.bush"
bad_test "badtest9.bush"
bad_test "badtest10.bush"
bad_test "badtest11.bush"
bad_test "badtest12.bush"
bad_test "badtest13.bush"
bad_test "badtest14.bush"
bad_test "badtest15.bush"
bad_test "badtest16.bush"
bad_test "badtest17.bush"
bad_test "badtest18.bush"
bad_test "badtest19.bush"
bad_test "badtest20.bush"
bad_test "badtest21.bush"
bad_test "badtest22.bush"
bad_test "badtest23.bush"
bad_test "badtest24.bush"
bad_test "badtest25.bush"
bad_test "badtest26.bush"
bad_test "badtest27.bush"
bad_test "badtest28.bush"
bad_test "badtest29.bush"
bad_test "badtest30.bush"
bad_test "badtest31.bush"
bad_test "badtest32.bush"
bad_test "badtest33.bush"
bad_test "badtest34.bush"
bad_test "badtest35.bush"
bad_test "badtest36.bush"
bad_test "badtest37.bush"
bad_test "badtest38.bush"
bad_test "badtest39.bush"
bad_test "badtest40.bush"
bad_test "badtest41.bush"
bad_test "badtest42.bush"
bad_test "badtest43.bush"
bad_test "badtest44.bush"
bad_test "badtest45.bush"
bad_test "badtest46.bush"
bad_test "badtest47.bush"
bad_test "badtest48.bush"
bad_test "badtest49.bush"
bad_test "badtest50.bush"
bad_test "badtest51.bush"
bad_test "badtest52.bush"
bad_test "badtest53.bush"
bad_test "badtest54.bush"
bad_test "badtest55.bush"
bad_test "badtest56.bush"
bad_test "badtest57.bush"
bad_test "badtest58.bush"
bad_test "badtest59.bush"
bad_test "badtest60.bush"
bad_test "badtest61.bush"
bad_test "badtest62.bush"
bad_test "badtest63.bush"
bad_test "badtest64.bush"
bad_test "badtest65.bush"
bad_test "badtest66.bush"
bad_test "badtest67.bush"
bad_test "badtest68.bush"
bad_test "badtest69.bush"
bad_test "badtest70.bush"
bad_test "badtest71.bush"
bad_test "badtest72.bush"
bad_test "badtest73.bush"
bad_test "badtest74.bush"
bad_test "badtest75.bush"
bad_test "badtest76.bush"
bad_test "badtest77.bush"
bad_test "badtest78.bush"
bad_test "badtest79.bush"
bad_test "badtest80.bush"
bad_test "badtest81.bush"
bad_test "badtest82.bush"
bad_test "badtest83.bush"
bad_test "badtest84.bush"
bad_test "badtest85.bush"
bad_test "badtest86.bush"
bad_test "badtest87.bush"
bad_test "badtest88.bush"
bad_test "badtest89.bush"
bad_test "badtest90.bush"
bad_test "badtest91.bush"
bad_test "badtest92.bush"
bad_test "badtest93.bush"
bad_test "badtest94.bush"
bad_test "badtest95.bush"
bad_test "badtest96.bush"
bad_test "badtest97.bush"
bad_test "badtest98.bush"
bad_test "badtest99.bush"
bad_test "badtesta0.bush"
bad_test "badtesta1.bush"
bad_test "badtesta2.bush"
bad_test "badtesta3.bush"
bad_test "badtesta4.bush"
bad_test "badtesta5.bush"
bad_test "badtesta6.bush"
bad_test "badtesta7.bush"
bad_test "badtesta8.bush"
bad_test "badtesta9.bush"
bad_test "badtestb0.bush"
bad_test "badtestb1.bush"
bad_test "badtestb2.bush"
bad_test "badtestb3.bush"
bad_test "badtestb4.bush"
bad_test "badtestb5.bush"
bad_test "badtestb6.bush"
bad_test "badtestb7.bush"
bad_test "badtestb8.bush"
bad_test "badtestb9.bush"
bad_test "badtestc0.bush"
bad_test "badtestc1.bush"
bad_test "badtestc2.bush"
bad_test "badtestc3.bush"
bad_test "badtestc4.bush"
bad_test "badtestc5.bush"
bad_test "badtestc6.bush"
bad_test "badtestc7.bush"
bad_test "badtestc8.bush"
bad_test "badtestc9.bush"
bad_test "badtestd0.bush"
bad_test "badtestd1.bush"
bad_test "badtestd2.bush"
bad_test "badtestd3.bush"
bad_test "badtestd4.bush"
bad_test "badtestd5.bush"
bad_test "badtestd6.bush"
bad_test "badtestd7.bush"
bad_test "badtestd8.bush"
bad_test "badtestd9.bush"
bad_test "badteste0.bush"
bad_test "badteste1.bush"
bad_test "badteste2.bush"
bad_test "badteste3.bush"
bad_test "badteste4.bush"
bad_test "badteste5.bush"
bad_test "badteste6.bush"
bad_test "badteste7.bush"
bad_test "badteste8.bush"
bad_test "badteste9.bush"
bad_test "badtestf0.bush"
bad_test "badtestf1.bush"
bad_test "badtestf2.bush"
bad_test "badtestf3.bush"
bad_test "badtestf4.bush"
bad_test "badtestf5.bush"
bad_test "badtestf6.bush"
bad_test "badtestf7.bush"
bad_test "badtestf8.bush"
bad_test "badtestf9.bush"
bad_test "badtestg0.bush"
bad_test "badtestg1.bush"
bad_test "badtestg2.bush"
bad_test "badtestg3.bush"
bad_test "badtestg4.bush"
bad_test "badtestg5.bush"
bad_test "badtestg6.bush"
bad_test "badtestg7.bush"
bad_test "badtestg8.bush"
bad_test "badtestg9.bush"
bad_test "badtesth0.bush"
bad_test "badtesth1.bush"
bad_test "badtesth2.bush"
bad_test "badtesth3.bush"
bad_test "badtesth4.bush"
bad_test "badtesth5.bush"
bad_test "badtesth6.bush"
bad_test "badtesth7.bush"
bad_test "badtesth8.bush"
bad_test "badtesth9.bush"
bad_test "badtesti0.bush"
bad_test "badtesti1.bush"
bad_test "badtesti2.bush"
bad_test "badtesti3.bush"
bad_test "badtesti4.bush"
bad_test "badtesti5.bush"
bad_test "badtesti6.bush"
bad_test "badtesti7.bush"
bad_test "badtesti8.bush"
bad_test "badtesti9.bush"
bad_test "badtestj0.bush"
bad_test "badtestj1.bush"
bad_test "badtestj2.bush"
bad_test "badtestj3.bush"
bad_test "badtestj4.bush"
bad_test_wparam "badtestj5.bush"
bad_test_wparam "badtestj6.bush"
bad_test_wparam "badtestj7.bush"

# Switch tests

../bush -n
if [ $RESULT -eq 0 ] ; then
     echo
     echo "--- $1 TEST FAILED - status code $RESULT ---"
     echo "Test was:"
     cat "$1"
     exit 1
fi
../bush -c
if [ $RESULT -eq 0 ] ; then
     echo
     echo "--- $1 TEST FAILED - status code $RESULT ---"
     echo "Test was:"
     cat "$1"
     exit 1
fi
../bush -c -n goodtest.bush a b c
if [ $RESULT -eq 0 ] ; then
     echo
     echo "--- $1 TEST FAILED - status code $RESULT ---"
     echo "Test was:"
     cat "$1"
     exit 1
fi

echo
echo "CONGRATULATIONS! ALL TESTS WERE SUCCESSFUL"
exit 0

